<?php

/*------------------------------------------------------------------------
# com_invoices - Invoice Manager for Joomla
# ------------------------------------------------------------------------
# author				Germinal Camps
# copyright 			Copyright (C) 2014 JoomlaThat.com. All Rights Reserved.
# @license				http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: 			http://www.JoomlaThat.com
# Technical Support:	Forum - http://www.JoomlaThat.com/support
-------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class  plgSystemInvoicemanager_fraudvoice extends JPlugin
{
	

	function plgSystemInvoicemanager_fraudvoice(& $subject, $config)
	{
		$lang = JFactory::getLanguage();
		$lang->load('com_invoices', JPATH_SITE);
		parent::__construct($subject, $config);
	}
	
	//Event: Catch the update of payment
	function oninvoicestatuschange($payment,$gatewayname='manualy'){
		//Debug
		mail('info@web-expert.gr','Payment',print_r($payment,true));
		$db =& JFactory::getDBO();

		$query = 	' UPDATE #__invoices_payments SET '.
					' payment_type =  "'.$payment->payment_type.'", '.
					' payment_datetime =  NOW(), '.
					' payment_details =  "'.$payment->payment_details.'", '.
					' payment_status =  '.$payment->payment_status.' '.
					' WHERE id = '.$payment->id .
					' LIMIT 1 ';
		
		$db->setQuery($query);
		$db->query();

	}
	
	//Import Customer order request to InvoiceManager
	function fraudvoiceNeworder($order, $client) {
		$client->orderid=$order->id;
		
		$orderitems=array();
		$orderitems[0]=new stdclass;
		$orderitems[0]->sku='Credits';
		$orderitems[0]->name='Credits Refill';
		$orderitems[0]->total=$order->total;
		$orderitems[0]->tax=$order->tax;
		$orderitems[0]->subtotal=$order->subtotal;
		$orderitems[0]->item_description='FraudVoice Service Credits Refill';
		
		$this->create_invoice($client, $orderitems);
		return true;
	}
	
	function create_invoice($details, $orderitems){
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_invoices'.DS.'helpers'.DS.'helpers.php');
		//print_r($data);die;
		$db = JFactory::getDBO();
		
		$component = "com_fraudvoice" ;

		//we check if this particular order had already been tracked
		$query = " SELECT id FROM #__invoices_invoices WHERE external_type = '".$component."' AND external_id = ".$details->orderid;
		$db->setQuery($query);
		$exists = $db->loadResult();

		//if it didn't exist, we attemp to create the conversion
		if(!$exists){

			$params = JComponentHelper::getParams( 'com_invoices' );

			$query = ' SELECT i.real_invoice_num FROM #__invoices_invoices as i WHERE i.type = 1  ORDER BY i.id DESC';
			$db->setQuery( $query );
			$real_invoice_num = $db->loadResult() + 1;
			$invoice_num = InvoicesHelper::getInvoiceNum($real_invoice_num) ;

			$taxes = array();

			$invoice_data = array(	
				"to_name" => $details->firstname." ".$details->lastname ,
				"to_company" => $details->company,
				"to_address" => $details->address_1,
				"to_email" => $details->email,
				"to_zipcode" => $details->postal,
				"to_city" => $details->city,
				"to_state" => $details->state,
				"to_country" => $details->country,
				"to_phone" => $details->phone,
				"to_vatid" => $details->vatid,
				"vincular_cliente_checkbox" => 2,
				"from_name" => $params->get('from_name'),
				"from_address" => $params->get('from_address'),
				"from_num" => $params->get('from_num'),
				"from_url" => $params->get('from_url'),
				"from_email" => $params->get('from_email'),
				"from_phone" => $params->get('from_phone'),
				"invoice_num" => $invoice_num,
				"real_invoice_num" => $real_invoice_num,
				"invoice_date" => date('Y-m-d H:i:s'),
				"template_id" => $params->get('invoice_template'),
				"currency_before" => $params->get('currency_before'),
				"currency_after" => $params->get('currency_after'),
				"publish" => $this->params->get('activation'),
				"start_publish" => "",
				"end_publish" => "",
				"joomla_user_id" => $details->userid,
				"taxes" => $taxes,
				"status" => 'unpaid', //always
				"external_type" => $component,
				"external_id" => $details->orderid
			) ;
			
			$items = array();

			foreach($orderitems as $orderitem){	
				$items[] = array(
					"sku" => $orderitem->sku,
					"name" => $orderitem->name,
					"desc" => $orderitem->description,
					"value" => $orderitem->subtotal,
					"amount" => $orderitem->total,
					"discount" => 0,
					"tax" => $orderitem->tax,
					"external_type" => $component,
					"product_id" => 1,
					);
			}						
			InvoicesHelper::create_invoice($invoice_data, $items, $payments=array());
		}
	}
	
function _logData($data)
	{
		$f = fopen(JPATH_CACHE . '/vm-invoices.txt', 'a');
		fwrite($f, "\n" . date('F j, Y, g:i a') . "\n");
		fwrite($f, print_r($data, true));
		fclose($f);
	}
	
}


